package com.alcatel.tpapps.common.server.testdeploy;

import org.apache.log4j.Appender;
import org.apache.log4j.Logger;
import org.infinispan.Cache;
import org.infinispan.CacheException;
import org.infinispan.manager.CacheContainer;
import org.jboss.as.ejb3.tx.CMTTxInterceptor;
import org.jboss.invocation.Interceptor;
import org.jboss.invocation.SimpleInterceptorFactoryContext;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.annotation.Resources;
import javax.ejb.DependsOn;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.management.Attribute;
import javax.management.MBeanServer;
import javax.management.MBeanServerConnection;
import javax.management.ObjectName;
import javax.management.remote.JMXConnector;
import javax.management.remote.JMXConnectorFactory;
import javax.management.remote.JMXServiceURL;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.persistence.Persistence;
import javax.persistence.spi.PersistenceUnitTransactionType;
import javax.transaction.Status;
import javax.transaction.TransactionSynchronizationRegistry;
import java.lang.management.ManagementFactory;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.Random;
import java.util.Set;
import java.util.TreeMap;

/**
 * Created with IntelliJ IDEA. User: rmorton Date: 2/4/14 Time: 12:41 PM To
 * change this template use File | Settings | File Templates.
 */
@Startup
@Singleton
@Resources  //EAP6
(
    {
        @Resource(name="java:jboss/" +
            TestJMXMBean.JNDI_NAME,
            lookup="java:global:/" +
            "dsc" + '/' +
            "tpapps-common-testdeploy" + '/' +
            "TestJMX" + '!' +
            TestJMXMBean.JNDI_NAME
        )
    }
)
//@DependsOn("GarbageLogCleaner")
public class TestJMX implements TestJMXMBean
{
    /**
     * A place to send logs.
     */
//    private static Logger logger = TPAResources.getLogger();
    private static Logger logger = Logger.getRootLogger();


    ObjectName objectName=null;

    /**
     * general purpose cache (i.e. neither web, hibernate, nor ejb)
     */
    @Resource(lookup="java:jboss/infinispan/container" +
            com.alcatel.tpapps.common.server.hacluster.
                    HATopologyMonitor.DSC_CLUSTER_NAME)
    private CacheContainer container;
    private Cache<String,Object> cache;

    @Resource(mappedName = "java:comp/TransactionSynchronizationRegistry")
    TransactionSynchronizationRegistry tsr;

    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    @PostConstruct
    public void start() throws Exception
    {
        //new Exception().printStackTrace();
        if(tsr != null)
            logger.info("MBean " + this.getClass().getName() +
                    " starting==> IN A TX?: " +
                    (Status.STATUS_NO_TRANSACTION != tsr.getTransactionStatus()));

        String serviceName = "AAA:type=" + this.getClass().getName();
        String status = "starting";
        logger.info(serviceName + " " + status);
        try {
            objectName = new ObjectName(serviceName);
            MBeanServer platformMBeanServer = ManagementFactory.getPlatformMBeanServer();
            platformMBeanServer.registerMBean(this, objectName);
        } catch (Exception e) {
            throw new IllegalStateException("Failed to register " + objectName + " into JMX:" + e);
        }
        status = "started & registered in jmx";
        logger.info(serviceName + " " + status);
    }

    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    @PreDestroy
    public void stop()
    {
        String status = "stopping";
        try {
            MBeanServer platformMBeanServer = ManagementFactory.getPlatformMBeanServer();
            platformMBeanServer.unregisterMBean(objectName);
        } catch (Exception e) {
            throw new IllegalStateException("Failed to unregister " + objectName + " from JMX:" + e);
        }
        status = "stopped & unregistered from jmx";
    }

}
